package im.zego.zimchatroomdemo;


import android.content.res.Resources;
import android.os.Build;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;

import im.zego.zimchatroomdemo.utils.KeyCenter;
import im.zego.zimchatroom.ZIMChatRoom;
import im.zego.zimchatroom.callback.OnLoginCallback;
import im.zego.zimchatroom.emus.ZIMChatRoomErrorCode;
import im.zego.zimchatroom.entity.ZIMChatRoomUserInfo;
import im.zego.zimchatroom.util.TokenServerAssistant;


import org.json.JSONException;

import im.zego.zimchatroomdemo.utils.MyToast;


public class MainActivity extends MyBaseActivity {
    private EditText etUserId;
    private EditText etUserName;
    private Button btnLogin;
    //login info
    String userID;
    String userName;
    //国际化资源
    Resources resource;
    //

    String[] permissionNeeded = {
            "android.permission.CAMERA",
            "android.permission.RECORD_AUDIO"};


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        resource = getResources();
        initUI();
    }

    private void initUI() {
        etUserId = findViewById(R.id.et_user_id);
        etUserName = findViewById(R.id.et_userName);
        btnLogin = findViewById(R.id.btn_login);
        btnLogin.setOnClickListener(this);
        etUserId.setText(getMobilePhoneBrandName());
    }

    @Override
    protected void onResume() {
        super.onResume();


    }

    @Override
    public void onClick(View v) {
        switch (v.getId()) {
            case R.id.btn_login:
                //点击button进行相应的数据传递和登录
                userID = etUserId.getText().toString();
                userName = etUserName.getText().toString();
                if (TextUtils.isEmpty(etUserName.getText().toString())) {
                    userName = etUserId.getText().toString();
                }
                if (userName.length() > 64) {
                    MyToast.showShortTimeToast(MainActivity.this, "用户名不能超过64字符");
                    return;
                }
                if (userID.length() > 32) {
                    MyToast.showShortTimeToast(MainActivity.this, "用户ID不能超过32字符");
                    return;
                }

                ZIMChatRoomUserInfo user = new ZIMChatRoomUserInfo();
                if (!(TextUtils.isEmpty(userID))) {
                    user.setUserID(userID);
                    user.setUserName(userName);
                    try {
                        //调用ChatRoom的SDK
                        ZIMChatRoom.getInstance().login(user, TokenServerAssistant.generateToken(KeyCenter.appID(), userID, KeyCenter.appZIMServerSecret(), 60 * 60 * 24).data, new OnLoginCallback() {
                            @Override
                            public void onConnectionState(ZIMChatRoomErrorCode error) {
                                if (error == ZIMChatRoomErrorCode.SUCCESS) {
                                    RoomLoginActivity.startActivity(MainActivity.this, userID, userName);
                                } else {
                                    MyToast.showShortTimeToast(MainActivity.this, resource.getString(R.string.toast_login_fail));
                                }
                            }
                        });
                    } catch (JSONException e) {
                        e.printStackTrace();
                    }
                } else {
                    MyToast.showShortTimeToast(MainActivity.this, resource.getString(R.string.toast_userid_login_fail));
                }
                break;
        }
    }

    //util 获取设备名称进行默认的UserID
    private String getMobilePhoneBrandName() {
        return Build.BRAND;
    }
}