package im.zego.zimchatroomdemo.adapter;

import static im.zego.zimchatroom.emus.ZIMChatRoomVoiceStatus.LOCKED;
import static im.zego.zimchatroom.emus.ZIMChatRoomVoiceStatus.UNUSED;
import static im.zego.zimchatroom.emus.ZIMChatRoomVoiceStatus.USED;

import android.content.res.Resources;
import android.graphics.Color;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import im.zego.zimchatroom.entity.ZIMVoiceSeat;
import im.zego.zimchatroomdemo.R;
import im.zego.zimchatroomdemo.adapter.holder.UserInChatListHolder;
import im.zego.zimchatroomdemo.adapter.holder.UserListHolder;
import im.zego.zimchatroomdemo.enums.RoomType;
import im.zego.zimchatroomdemo.roomchatActivity.RoomBaseActivity;

import java.util.ArrayList;

//展示所有在舞台中麦位用户列表，包括上麦和闭麦等等
public class MemberListAdapter extends RecyclerView.Adapter {
    public ArrayList<ZIMVoiceSeat> getSeatListInRoom() {
        return seatListInRoom;
    }

    //相关的Seat参数等到后期再进行设计
    public ArrayList<ZIMVoiceSeat> seatListInRoom = new ArrayList<>();
    RoomType roomType;
    Resources resources;

    public MemberListAdapter(RoomType roomType) {
        this.roomType = roomType;
        resources = RoomBaseActivity.resources;
    }

    public ChatListItemOnClick click = null;

    @NonNull
    @Override
    public RecyclerView.ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        //视图绑定，通过获取它的view进行渲染
        View view = LayoutInflater.from(parent.getContext()).inflate(R.layout.item_chat_user, parent, false);
        UserListHolder holder = new UserListHolder(view);
        return holder;
    }

    @Override
    public void onBindViewHolder(@NonNull RecyclerView.ViewHolder holder, int position) {
        UserListHolder userListHolder = (UserListHolder) holder;
    }

    @Override
    public int getItemCount() {
        return seatListInRoom.size();//默认为8个麦位
    }

    public void updateUserInfo(int index, ZIMVoiceSeat zimVoiceSeat) {
        seatListInRoom.set(index, zimVoiceSeat);
        this.notifyItemChanged(index);

    }

    public void setItemOnClick(ChatListItemOnClick click) {
        this.click = click;
    }

    public interface ChatListItemOnClick {
        public void onClick(int index);
    }
}
