package im.zego.zimchatroomdemo.adapter;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import im.zego.zimchatroom.entity.ZIMChatRoomMessage;
import im.zego.zimchatroom.entity.ZIMChatRoomText;
import im.zego.zimchatroomdemo.R;
import im.zego.zimchatroomdemo.adapter.holder.MessageHolder;
import im.zego.zimchatroomdemo.roomchatActivity.RoomBaseActivity;

import java.util.ArrayList;

//展示所有的发送过来的信息
public class MessageListAdapter extends RecyclerView.Adapter {
    ArrayList<ZIMChatRoomText> textMessage = new ArrayList<>();

    public MessageListAdapter(ArrayList<ZIMChatRoomText> textMessage) {
        this.textMessage = textMessage;
    }

    @NonNull
    @Override
    public RecyclerView.ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        //视图绑定，通过获取它的view进行渲染
        View view = LayoutInflater.from(parent.getContext()).inflate(R.layout.item_message, parent, false);
        MessageHolder messageHolder = new MessageHolder(view);
        return messageHolder;
    }

    @Override
    public void onBindViewHolder(@NonNull RecyclerView.ViewHolder holder, int position) {
        MessageHolder messageHolder = (MessageHolder) holder;
        ZIMChatRoomText message = textMessage.get(position);
        if (isOwnerMassage(position)) {
            //判断是否房主的消息，是就展现房主符号和相关信息
            messageHolder.ivOwnerAvatar.setVisibility(View.VISIBLE);

        } else {
            messageHolder.ivOwnerAvatar.setVisibility(View.GONE);
        }
        messageHolder.tvSendMessage.setText(message.getContent());//设置文本信息
        messageHolder.tvSendUserName.setText(message.getFromUserID());//展示userID
    }

    @Override
    public int getItemCount() {
        return textMessage.size();
    }

    //util
    private boolean isOwnerMassage(int position) {
        String s = RoomBaseActivity.authorID;
        String userID = textMessage.get(position).getFromUserID();
        if (userID == null) {
            return false;
        }
        return userID.equals(s);
    }


}
