package im.zego.zimchatroomdemo.adapter;

import static android.view.View.GONE;
import static android.view.View.INVISIBLE;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.CompoundButton;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import im.zego.zimchatroom.entity.ZIMVoiceSeat;
import im.zego.zimchatroomdemo.R;
import im.zego.zimchatroomdemo.adapter.holder.SendGiftToUserListHolder;

import java.util.ArrayList;

//展示可发送礼物的用户的列表，点击用户名可发送礼物
public class SendGiftToUserListAdapter extends RecyclerView.Adapter {
    ArrayList<ZIMVoiceSeat> usersInSeatExceptSelf;
    public SendGiftToUserListAdapter.ChatListItemOnClick click;

    public SendGiftToUserListAdapter(ArrayList<ZIMVoiceSeat> usersInSeatExceptSelf) {
        this.usersInSeatExceptSelf = usersInSeatExceptSelf;

    }

    @NonNull
    @Override
    public RecyclerView.ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        //视图绑定，通过获取它的view进行渲染
        View view = LayoutInflater.from(parent.getContext()).inflate(R.layout.item_send_gift_user, parent, false);
        //holder
        SendGiftToUserListHolder sendGiftToUserListHolder = new SendGiftToUserListHolder(view);
        return sendGiftToUserListHolder;
    }

    @Override
    public void onBindViewHolder(@NonNull RecyclerView.ViewHolder holder, int position) {
        final SendGiftToUserListHolder sendGiftToUserListHolder = (SendGiftToUserListHolder) holder;
        sendGiftToUserListHolder.tvUserName.setText(usersInSeatExceptSelf.get(position).getAttribution().getUser_id());
        sendGiftToUserListHolder.ivChosen.setTag(position);
        sendGiftToUserListHolder.ivChosen.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                final SendGiftToUserListAdapter.ChatListItemOnClick chatListItemOnClick = click;
                if (chatListItemOnClick != null) {
                    int position = (int) buttonView.getTag();
                    if (usersInSeatExceptSelf != null) {
                        String userID = usersInSeatExceptSelf.get(position).getAttribution().getUser_id();
                        chatListItemOnClick.onCheckedChanged(position, userID, isChecked);
                    }
                }
            }
        });
    }

    @Override
    public int getItemViewType(int position) {
        return position;
    }

    @Override
    public int getItemCount() {
        return usersInSeatExceptSelf.size();
    }

    public void setItemCheckedChangeListener(SendGiftToUserListAdapter.ChatListItemOnClick click) {
        this.click = click;
    }

    public interface ChatListItemOnClick {
        public void onCheckedChanged(int index, String userID, boolean isChecked);
    }
}
