package im.zego.zimchatroomdemo.adapter;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.CompoundButton;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import im.zego.zimchatroom.ZIMChatRoom;
import im.zego.zimchatroom.callback.LockSeatCallback;
import im.zego.zimchatroom.callback.MuteAllMessageCallback;
import im.zego.zimchatroom.emus.ZIMChatRoomErrorCode;
import im.zego.zimchatroom.emus.ZIMChatRoomVoiceStatus;
import im.zego.zimchatroom.entity.ZIMVoiceSeat;
import im.zego.zimchatroomdemo.R;
import im.zego.zimchatroomdemo.adapter.holder.SetHolder;
import im.zego.zimchatroomdemo.enums.SetType;

import java.util.ArrayList;

//展示所有的Set供用户进行相应的设置
public class SetListAdapter extends RecyclerView.Adapter {
    //相关的参数等到后期再进行设计
    ArrayList<SetType> setTypes;
    public ArrayList<ZIMVoiceSeat> locked_seat_list = new ArrayList<>();
    public boolean isCheckedMuteMessage;

    public SetListAdapter(ArrayList<SetType> setTypes, ArrayList<ZIMVoiceSeat> locked_seat_list) {
        this.setTypes = setTypes;
        this.locked_seat_list = locked_seat_list;
    }

    @NonNull
    @Override
    public RecyclerView.ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        //视图绑定，通过获取它的view进行渲染
        View view = LayoutInflater.from(parent.getContext()).inflate(R.layout.item_set, parent, false);
        SetHolder setHolder = new SetHolder(view);
        if (viewType == SetType.ALLOW_SPEAK.getValue()) {
            setHolder.tvSet.setText("是否禁言");
            setHolder.scSet.setChecked(isCheckedMuteMessage);
            setHolder.scSet.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
                @Override
                public void onCheckedChanged(CompoundButton buttonView, final boolean isChecked) {
                    //进行静音操作
                    ZIMChatRoom.getInstance().muteAllMessage(isChecked, new MuteAllMessageCallback() {
                        @Override
                        public void onMuteAllMessage(ZIMChatRoomErrorCode error) {
                            if (error.equals(ZIMChatRoomErrorCode.SUCCESS))
                                isCheckedMuteMessage = isChecked;
                        }
                    });
                }
            });
        } else {
            setHolder.tvSet.setText("是否允许上麦");
            setHolder.tvSetInfo.setVisibility(View.VISIBLE);
            setHolder.scSet.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
                @Override
                public void onCheckedChanged(CompoundButton buttonView, final boolean isChecked) {

                }
            });
        }
        return setHolder;
    }

    @Override
    public void onBindViewHolder(@NonNull RecyclerView.ViewHolder holder, int position) {
        SetHolder setHolder = (SetHolder) holder;
    }

    @Override
    public int getItemViewType(int position) {
        if (setTypes.get(position) == SetType.ALLOW_SPEAK) {
            return SetType.ALLOW_SPEAK.getValue();//
        } else {
            return SetType.ALLOW_TAKE_SEAT.getValue();
        }
    }

    @Override
    public int getItemCount() {
        return setTypes.size();
    }
}
