package im.zego.zimchatroomdemo.adapter;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import im.zego.zimchatroom.ZIMChatRoom;
import im.zego.zimchatroomdemo.R;
import im.zego.zimchatroomdemo.adapter.holder.UserInRoomListHolder;
import im.zego.zimchatroomdemo.entity.MemberInfo;
import im.zego.zimchatroomdemo.enums.RoomType;
import im.zego.zimchatroomdemo.roomchatActivity.RoomBaseActivity;

import java.util.ArrayList;

//展示用户列表，在该房间的所有的User界面，存在普通的UI界面
public class UserInRoomListAdapter extends RecyclerView.Adapter {

    ArrayList<MemberInfo> userListInRoom;
    RoomType roomUserRole;
    public UserInRoomListAdapter.ChatListItemOnClick click = null;
    //ChatRoom
    ZIMChatRoom chatRoom = ZIMChatRoom.getInstance();
    String authorID = "";

    public UserInRoomListAdapter(ArrayList<MemberInfo> userListInRoom, RoomType roomUserRole, String authorID) {
        this.userListInRoom = userListInRoom;
        this.authorID = authorID;
        this.roomUserRole = roomUserRole;
    }

    //相关的User参数等到后期再进行设计
    @NonNull
    @Override
    public RecyclerView.ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        //视图绑定，通过获取它的view进行渲染
        View view = LayoutInflater.from(parent.getContext()).inflate(R.layout.item_list_user, parent, false);
        UserInRoomListHolder userInRoomListHolder = new UserInRoomListHolder(view);
        return userInRoomListHolder;
    }

    @Override
    public void onBindViewHolder(@NonNull RecyclerView.ViewHolder holder, int position) {
        final UserInRoomListHolder userInRoomListHolder = (UserInRoomListHolder) holder;
        final MemberInfo chatRoomUser = userListInRoom.get(position);
        userInRoomListHolder.tvUserName.setText(chatRoomUser.userID);

        if (chatRoomUser.showInvitation && roomUserRole == RoomType.TYPE_ROOM_OWNER) {
            userInRoomListHolder.btnInvite.setVisibility(View.VISIBLE);
            userInRoomListHolder.btnInvite.setText(RoomBaseActivity.resources.getString(R.string.invite_visitor));

            userInRoomListHolder.btnInvite.setEnabled(true);
        } else {
            if (!chatRoomUser.showInvitation && roomUserRole == RoomType.TYPE_ROOM_OWNER && !authorID.equals(chatRoomUser.userID)) {
                userInRoomListHolder.btnInvite.setText("已在麦上");
                userInRoomListHolder.btnInvite.setEnabled(false);
                userInRoomListHolder.btnInvite.setVisibility(View.VISIBLE);
            } else {
                userInRoomListHolder.btnInvite.setVisibility(View.GONE);
            }

        }
        if (authorID != null && authorID.equals(chatRoomUser.userID)) {
            userInRoomListHolder.ivOwnerAvatar.setVisibility(View.VISIBLE);
        } else {
            userInRoomListHolder.ivOwnerAvatar.setVisibility(View.GONE);
        }

        //设置点击事件
        userInRoomListHolder.btnInvite.setTag(userListInRoom.get(position).userID);
        userInRoomListHolder.btnInvite.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                final UserInRoomListAdapter.ChatListItemOnClick chatListItemOnClick = click;
                if (chatListItemOnClick != null) {
                    String userID = (String) v.getTag();
                    chatListItemOnClick.onClick(userID);
                }
            }
        });
    }


    @Override
    public int getItemCount() {
        return userListInRoom.size();
    }

    public void setItemOnClick(UserInRoomListAdapter.ChatListItemOnClick click) {
        this.click = click;
    }

    public interface ChatListItemOnClick {
        public void onClick(String userID);
    }


}
