package im.zego.zimchatroomdemo.roomchatActivity;

import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.res.Resources;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.View;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.RelativeLayout;
import android.widget.TextView;
import android.widget.Toast;

import androidx.recyclerview.widget.GridLayoutManager;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import im.zego.zimchatroom.ZIMChatRoom;
import im.zego.zimchatroom.callback.EnterSeatCallback;
import im.zego.zimchatroom.callback.LeaveSeatCallback;
import im.zego.zimchatroom.callback.LockSeatCallback;
import im.zego.zimchatroom.callback.MuteSeatCallback;
import im.zego.zimchatroom.callback.OnLeaveCallback;
import im.zego.zimchatroom.callback.OnQueryChatRoomInfoCallback;
import im.zego.zimchatroom.callback.OnQueryRoomMemberCallback;
import im.zego.zimchatroom.callback.SendGiftMessageCallback;
import im.zego.zimchatroom.callback.SendInvitationStatusCallback;
import im.zego.zimchatroom.callback.SendRoomMessageCallback;
import im.zego.zimchatroom.callback.ZIMChatRoomEventHandler;
import im.zego.zimchatroom.emus.ZIMChatRoomErrorCode;
import im.zego.zimchatroom.emus.ZIMChatRoomEvent;
import im.zego.zimchatroom.emus.ZIMChatRoomInvitationStatus;
import im.zego.zimchatroom.emus.ZIMChatRoomState;
import im.zego.zimchatroom.emus.ZIMChatRoomUserRole;
import im.zego.zimchatroom.emus.ZIMChatRoomVoiceStatus;
import im.zego.zimchatroom.internal.entity.ZIMChatRoomInfo;
import im.zego.zimchatroom.entity.ZIMChatRoomQueryMemberConfig;
import im.zego.zimchatroom.entity.ZIMChatRoomText;
import im.zego.zimchatroom.entity.ZIMChatRoomUser;
import im.zego.zimchatroom.entity.ZIMVoiceSeat;
import im.zego.zimchatroom.entity.ZIMVoiceSeatUpdateInfo;
import im.zego.zimchatroom.util.TokenServerAssistant;
import im.zego.zimchatroom.util.ZegoRTCServerAssistant;

import im.zego.zimchatroomdemo.MyBaseActivity;
import im.zego.zimchatroomdemo.R;
import im.zego.zimchatroomdemo.adapter.MessageListAdapter;
import im.zego.zimchatroomdemo.adapter.UserInChatListAdapter;
import im.zego.zimchatroomdemo.enums.GiftType;
import im.zego.zimchatroomdemo.enums.RoomType;
import im.zego.zimchatroomdemo.roomchatActivity.popdialog.GiftPopDialog;
import im.zego.zimchatroomdemo.roomchatActivity.popdialog.MemberRoomGiftPopDialog;
import im.zego.zimchatroomdemo.roomchatActivity.popdialog.SetPopDialog;
import im.zego.zimchatroomdemo.utils.KeyCenter;

import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

//这里是两种不同类型的房间activity的父类
public class RoomBaseActivity extends MyBaseActivity {
    //ZIMChatRoom assets
    public static ZIMChatRoomInfo chatRoomInfo = new ZIMChatRoomInfo();
    //该房间内的所有的用户
    public static ArrayList<ZIMChatRoomUser> userListInRoom = new ArrayList<>();
    //资源,用于访问国际化
    public static Resources resources;
    //本地的用户
    public static ZIMChatRoomUser user;
    String roomID, roomName;
    String userID, userName;
    LinearLayoutManager linearLayoutManager;
    ZIMChatRoomUserRole userRole;
    ZIMChatRoomQueryMemberConfig config = new ZIMChatRoomQueryMemberConfig();

    //All ui assets
    TextView tvChatRoom;
    RelativeLayout rlToolbar;
    ImageView ivBack;
    TextView tvRoomName;
    public static TextView tvRoomNum;//实时更新房间人数
    ImageView ivQueryMember;
    public static TextView tvBanner;//用于展示横幅
    RecyclerView rvSeatList;
    RecyclerView rvMessageList;
    Button btnLogoutMicrophone;
    Button btnTurnOffMicrophone;
    public static EditText etMessage;
    Button btnSend;
    ImageView ivGift;
    ImageView ivSet;
    // Adapter
    public UserInChatListAdapter userInChatListAdapter;//麦位的
    public MessageListAdapter messageListAdapter;
    // 获取ChatRoomSDK管理
    ZIMChatRoom chatRoom = ZIMChatRoom.getInstance();
    //popDialog
    SetPopDialog setPopDialog;
    GiftPopDialog giftPopDialog;

    public static String authorID = "";
    public ArrayList<ZIMChatRoomText> textMessage = new ArrayList<>();

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_room_base);
        getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_UNSPECIFIED);
        resources = getResources();
        config.setNextFlag("");
        config.setCount(100);

        chatRoom.setZIMChatRoomEventHandler(new ZIMChatRoomEventHandler() {
            @Override
            public void onChatRoomStateUpdated(ZIMChatRoomState state, ZIMChatRoomEvent event, String roomID) {
                if (state == ZIMChatRoomState.DISCONNECTED) {
                    finish();
                    Toast.makeText(RoomBaseActivity.this, "房间断开链接，请重新登录!", Toast.LENGTH_LONG).show();
                }
            }

            @Override
            public void onRTCTokenWillExpire(String roomID, int remainTimeInSecond) {
                ZegoRTCServerAssistant.Privileges privileges = new ZegoRTCServerAssistant.Privileges();
                privileges.canLoginRoom = true;
                privileges.canPublishStream = true;
                chatRoom.renewRTCToken(ZegoRTCServerAssistant.generateToken(KeyCenter.appID(), roomID, userID, privileges, KeyCenter.appExpressSign(), 660).data);
            }

            @Override
            public void onZIMTokenWillExpire(int time) {
                try {
                    chatRoom.renewZIMToken(TokenServerAssistant.generateToken(KeyCenter.appID(), userID, KeyCenter.appZIMServerSecret(), 660).data);
                } catch (JSONException e) {
                    e.printStackTrace();
                }

            }

            @Override
            public void onChatRoomInfoUpdated(ZIMChatRoomInfo chatRoomInfo) {
                //更新整个房间属性的值
                if (chatRoomInfo == null) {
                    Toast.makeText(RoomBaseActivity.this, "房间已被解散", Toast.LENGTH_LONG).show();
                    finish();
                } else {
                    authorID = chatRoomInfo.getAuthor();
                    userInChatListAdapter.setAuthorID(authorID);
                    userInChatListAdapter.notifyItemChanged(0);
                    tvRoomName.setText(chatRoomInfo.getRoom_Name());
                }
            }

            @Override
            public void onChatRoomMemberLeft(ArrayList<ZIMChatRoomUser> userList) {
                for (ZIMChatRoomUser user : userList) {
                    String msg = "系统通知:" + user.getUserID() + " 已退出房间";
                    ZIMChatRoomText zimChatRoomText = new ZIMChatRoomText();
                    zimChatRoomText.setContent(msg);
                    textMessage.add(zimChatRoomText);
                    refreshMessageList();

                }
                chatRoom.queryRoomMember(chatRoomInfo.getRoom_id(), config, new OnQueryRoomMemberCallback() {
                    @Override
                    public void onQueryRoomMember(ArrayList<ZIMChatRoomUser> userList, String nextFlag, ZIMChatRoomErrorCode errorCode) {
                        tvRoomNum.setText("(" + userList.size() + "人)");
                    }
                });
            }

            @Override
            public void onChatRoomMemberJoined(ArrayList<ZIMChatRoomUser> userList) {
                for (ZIMChatRoomUser user : userList) {
                    String msg = "系统通知:" + user.getUserID() + " 加入房间";
                    ZIMChatRoomText zimChatRoomText = new ZIMChatRoomText();
                    zimChatRoomText.setContent(msg);
                    textMessage.add(zimChatRoomText);
                    refreshMessageList();

                }
                chatRoom.queryRoomMember(chatRoomInfo.getRoom_id(), config, new OnQueryRoomMemberCallback() {
                    @Override
                    public void onQueryRoomMember(ArrayList<ZIMChatRoomUser> userList, String nextFlag, ZIMChatRoomErrorCode errorCode) {
                        tvRoomNum.setText("(" + userList.size() + "人)");
                    }
                });
            }

            @Override
            public void onReceiveRoomMassage(String message, String fromUserID) {
                ZIMChatRoomText zimChatRoomText = new ZIMChatRoomText();
                zimChatRoomText.setContent(message);
                zimChatRoomText.setFromUserID(fromUserID);
                textMessage.add(zimChatRoomText);
                refreshMessageList();
            }

            @Override
            public void onReceiveGiftMessage(int giftType, String fromUserID) {
                super.onReceiveGiftMessage(giftType, fromUserID);
            }

            @Override
            public void onReceiveGiftBroadcastMessage(List<String> toUSerIDList, int giftType, String fromUserID) {
                if (toUSerIDList != null) {
                    StringBuffer stringNameList = new StringBuffer();
                    stringNameList.append(fromUserID);
                    stringNameList.append("给");
                    for (String user : toUSerIDList) {
                        stringNameList.append(user);
                        if (toUSerIDList.size() > 1) {
                            stringNameList.append("/");
                        }
                    }
                    stringNameList.append("送出了666");
                    showGiftPop(stringNameList.toString());
                }
            }

            @Override
            public void onReceiveInvitation(String fromUserID) {
                super.onReceiveInvitation(fromUserID);
                AlertDialog.Builder builder = new AlertDialog.Builder(RoomBaseActivity.this);
                builder.setTitle(getResources().getString(R.string.dialog_remind));
                builder.setMessage(getResources().getString(R.string.dialog_invite_message));
                builder.setNegativeButton(getResources().getString(R.string.dialog_confirm), new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        chatRoom.respondInvitation(ZIMChatRoomInvitationStatus.ACCEPT, new SendInvitationStatusCallback() {
                            @Override
                            public void sendInvitationStatus(ZIMChatRoomErrorCode errorCode) {
                                if (errorCode == ZIMChatRoomErrorCode.SUCCESS) {
                                    ArrayList<ZIMVoiceSeat> zimVoiceSeats = userInChatListAdapter.getSeatListInRoom();
                                    boolean isSeat = false;
                                    for (ZIMVoiceSeat zimVoiceSeat : zimVoiceSeats) {
                                        if (zimVoiceSeat.getStatus() == ZIMChatRoomVoiceStatus.UNUSED) {
                                            chatRoom.enterSeat(zimVoiceSeat.getAttribution().getIndex(), new EnterSeatCallback() {
                                                @Override
                                                public void enterSeat(ZIMChatRoomErrorCode error) {
                                                }
                                            });
                                            return;
                                        }
                                    }
                                    Toast.makeText(RoomBaseActivity.this, "已没有可用的麦位", Toast.LENGTH_LONG).show();
                                }
                            }
                        });
                        dialog.cancel();
                    }
                });

                builder.setPositiveButton(getResources().getString(R.string.dialog_cancel), new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        chatRoom.respondInvitation(ZIMChatRoomInvitationStatus.REJECT, new SendInvitationStatusCallback() {
                            @Override
                            public void sendInvitationStatus(ZIMChatRoomErrorCode errorCode) {

                            }
                        });
                        dialog.cancel();
                    }
                });

                AlertDialog dialog = builder.create();
                dialog.show();
            }

            @Override
            public void onResponseInvitation(ZIMChatRoomInvitationStatus zimChatRoomInvitationStatus, String fromUserID) {
                super.onResponseInvitation(zimChatRoomInvitationStatus, fromUserID);
            }

            @Override
            public void onMuteAllMessage(boolean isMuted) {
                if (isMuted) {
                    etMessage.setHint(getResources().getString(R.string.no_speech));
                    etMessage.setClickable(false);
                } else {
                    etMessage.setHint(getResources().getString(R.string.say_something));
                    etMessage.setClickable(true);
                }
            }

            @Override
            public void onChatRoomVoiceSeatUpdated(ArrayList<ZIMVoiceSeatUpdateInfo> voiceSeatUpdateInfos) {
                for (ZIMVoiceSeatUpdateInfo info : voiceSeatUpdateInfos) {
                    //根据麦位的下标针对数组下标操作
                    ZIMVoiceSeat voiceSeat = info.getVoiceSeat();
                    int index = voiceSeat.getAttribution().getIndex();

                    if (userID.equals(info.getVoiceSeat().getAttribution().getUser_id()) && info.getVoiceSeat().getStatus() == ZIMChatRoomVoiceStatus.USED) {
                        btnTurnOffMicrophone.setVisibility(View.VISIBLE);
                        if (getRoomType() == RoomType.TYPE_ROOM_VISITOR) {
                            btnLogoutMicrophone.setVisibility(View.VISIBLE);
                        }
                    } else if (userID.equals(info.getVoiceSeat().getAttribution().getUser_id()) && info.getVoiceSeat().getStatus() == ZIMChatRoomVoiceStatus.UNUSED) {
                        btnLogoutMicrophone.setVisibility(View.GONE);
                        btnTurnOffMicrophone.setVisibility(View.GONE);
                        voiceSeat.getAttribution().setUser_id("");
                    } else if (!userID.equals(info.getVoiceSeat().getAttribution().getUser_id()) && info.getVoiceSeat().getStatus() == ZIMChatRoomVoiceStatus.UNUSED) {
                        if (setPopDialog != null && setPopDialog.isCheckedTakSeat && getRoomType() == RoomType.TYPE_ROOM_OWNER) {
                            chatRoom.lockSeat(true, info.getVoiceSeat().getAttribution().getIndex(), new LockSeatCallback() {
                                @Override
                                public void lockSeat(ZIMChatRoomErrorCode error) {

                                }
                            });
                        }
                        voiceSeat.getAttribution().setUser_id("");
                    }
                    userInChatListAdapter.updateUserInfo(index, voiceSeat);

                }
            }

            @Override
            public void OnRemoteUserSoundLevelUpdated(HashMap<String, Float> soundLevel) {
                super.OnRemoteUserSoundLevelUpdated(soundLevel);
            }


            @Override
            public void onConnectionStateChanged(ZIMChatRoomState state, ZIMChatRoomEvent event, JSONObject extendedData) {
                if (state == ZIMChatRoomState.DISCONNECTED) {
                    Intent intent = getIntent();
                    setResult(100, intent);
                    finish();
                    Toast.makeText(RoomBaseActivity.this, "已经断开链接，请重新登录", Toast.LENGTH_LONG).show();
                }
            }
        });
        initUI();


        tvRoomNum.postDelayed(new Runnable() {
            @Override
            public void run() {
                chatRoom.queryChatRoomInfo(chatRoomInfo.getRoom_id(), new OnQueryChatRoomInfoCallback() {
                    @Override
                    public void onQueryRoomMember(ZIMChatRoomInfo info) {
                        if (info != null) {
                            authorID = info.getAuthor();
                            tvRoomName.setText(info.getRoom_Name());
                        }
                    }
                });

                chatRoom.queryRoomMember(chatRoomInfo.getRoom_id(), config, new OnQueryRoomMemberCallback() {
                    @Override
                    public void onQueryRoomMember(ArrayList<ZIMChatRoomUser> userList, String nextFlag, ZIMChatRoomErrorCode errorCode) {
                        tvRoomNum.setText("(" + userList.size() + "人)");
                    }
                });
            }
        }, 3000);


    }

    private void refreshMessageList() {
        messageListAdapter.notifyItemInserted(textMessage.size());
        rvMessageList.scrollToPosition(messageListAdapter.getItemCount() - 1);
    }


    protected void initUI() {
        tvChatRoom = findViewById(R.id.tv_chat_room);
        rlToolbar = findViewById(R.id.rl_toolbar);
        ivBack = findViewById(R.id.iv_back);
        tvRoomName = findViewById(R.id.tv_room_name);
        tvRoomNum = findViewById(R.id.tv_room_num);
        ivQueryMember = findViewById(R.id.iv_query_member);
        tvBanner = findViewById(R.id.tv_banner);
        rvSeatList = findViewById(R.id.rv_seat_list);
        rvMessageList = findViewById(R.id.rv_message_list);
        btnLogoutMicrophone = findViewById(R.id.btn_logout_microphone);
        btnTurnOffMicrophone = findViewById(R.id.btn_turn_off_microphone);
        etMessage = findViewById(R.id.et_message);
        btnSend = findViewById(R.id.btn_send);
        ivGift = findViewById(R.id.iv_gift);
        ivSet = findViewById(R.id.iv_set);
        //适配器
        messageListAdapter = new MessageListAdapter(textMessage);
        userInChatListAdapter = new UserInChatListAdapter(getRoomType());
        btnTurnOffMicrophone.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (btnTurnOffMicrophone.getText().equals("闭麦")) {
                    btnTurnOffMicrophone.setText("开麦");
                    chatRoom.muteSeat(true, new MuteSeatCallback() {
                        @Override
                        public void muteSeat(ZIMChatRoomErrorCode error) {

                        }
                    });
                } else {
                    btnTurnOffMicrophone.setText("闭麦");
                    chatRoom.muteSeat(false, new MuteSeatCallback() {
                        @Override
                        public void muteSeat(ZIMChatRoomErrorCode error) {

                        }
                    });
                }
            }
        });
        btnLogoutMicrophone.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (btnLogoutMicrophone.getText().equals("下麦")) {
                    chatRoom.leaveSeat(new LeaveSeatCallback() {
                        @Override
                        public void leaveSeat(ZIMChatRoomErrorCode error) {
                            if (error == ZIMChatRoomErrorCode.SUCCESS) {
                                btnTurnOffMicrophone.setText("闭麦");
                            }
                        }
                    });
                }
            }
        });
    }

    @Override
    protected void onStart() {
        super.onStart();
    }

    @Override
    protected void onResume() {
        super.onResume();
        //这里需要适配器进行适配，例如UserList以及MessageList等等,这个可以由不同的子类实现
        if (getRoomType().equals(RoomType.TYPE_ROOM_OWNER)) {
            //房主端，只有开闭麦，没有上下麦，它是必须在麦位上的
            btnLogoutMicrophone.setVisibility(View.GONE);
            btnTurnOffMicrophone.setVisibility(View.VISIBLE);
            userRole = ZIMChatRoomUserRole.OWNER;
        } else {
            ivSet.setVisibility(View.GONE);//进行gone-视图
            btnLogoutMicrophone.setVisibility(View.INVISIBLE);
            btnTurnOffMicrophone.setVisibility(View.INVISIBLE);//这两个button是点击空位才可以展现并且进行相应的操作
            userRole = ZIMChatRoomUserRole.VISITOR;
        }

        ivSet.setOnClickListener(this);
        ivGift.setOnClickListener(this);
        ivBack.setOnClickListener(this);
        ivQueryMember.setOnClickListener(this);
        //发送消息按钮
        btnSend.setOnClickListener(this);
        //message 和 user的 view设计
        linearLayoutManager = new LinearLayoutManager(RoomBaseActivity.this, LinearLayoutManager.VERTICAL, false);

        GridLayoutManager gridLayoutManager = new GridLayoutManager(RoomBaseActivity.this, 4);
        //适配器匹配
        //麦位模块
        rvSeatList.setAdapter(userInChatListAdapter);
        rvSeatList.setLayoutManager(gridLayoutManager);
        //消息模块
        rvMessageList.setAdapter(messageListAdapter);
        rvMessageList.setLayoutManager(linearLayoutManager);
    }

    protected RoomType getRoomType() {
        return RoomType.TYPE_ROOM_VISITOR;
    }

    public void showGiftPop(String msg) {
        tvBanner.setText(msg);
        View view = tvBanner;
        if (view != null) {
            view.postDelayed(new Runnable() {
                @Override
                public void run() {
                    tvBanner.setText("");
                }
            }, 10000);
        }
    }

    // 添加set和gift的ui设计
    @Override
    public void onClick(View v) {
        super.onClick(v);
        switch (v.getId()) {
            case R.id.iv_gift:
                giftPopDialog = new GiftPopDialog(RoomBaseActivity.this, R.layout.pop_gift, false, false, userInChatListAdapter.getSeatListInRoom(), userID, new GiftPopDialog.GiftPopSendCallback() {
                    @Override
                    public void sendGiftMessage(ArrayList<String> userIDs, GiftType giftType) {
                        ZIMChatRoom.getInstance().sendGiftMessage(giftType.getValue(), userIDs, new SendGiftMessageCallback() {
                            @Override
                            public void onSendGiftMessage(ZIMChatRoomErrorCode error, List<String> sendFailToUsers) {
                                StringBuffer stringNameList = new StringBuffer();
                                stringNameList.append(userID);
                                stringNameList.append("给:");
                                for (String user : userIDs) {
                                    stringNameList.append(user);
                                    if (userIDs.size() > 1) {
                                        stringNameList.append("/");
                                    }
                                }
                                stringNameList.append("送出了666");
                                showGiftPop(stringNameList.toString());
                            }
                        });
                    }
                });
                giftPopDialog.show();
                break;
            case R.id.iv_set:
                setPopDialog = new SetPopDialog(RoomBaseActivity.this, R.layout.item_set, false, false, userInChatListAdapter);
                setPopDialog.show();
                break;
            case R.id.iv_back:
                //退房
                chatRoom.leaveChatRoom(chatRoomInfo.getRoom_id(), new OnLeaveCallback() {
                    @Override
                    public void onConnectionState(ZIMChatRoomErrorCode error) {

                    }
                });
                chatRoomInfo = new ZIMChatRoomInfo();//更新掉所有的房间属性信息
                userListInRoom = new ArrayList<>();
                finish();
                break;
            case R.id.iv_query_member:
                ZIMChatRoomQueryMemberConfig config = new ZIMChatRoomQueryMemberConfig();
                config.setNextFlag("");
                config.setCount(100);
                chatRoom.queryRoomMember(chatRoomInfo.getRoom_id(), config, new OnQueryRoomMemberCallback() {
                    @Override
                    public void onQueryRoomMember(ArrayList<ZIMChatRoomUser> userList, String nextFlag, ZIMChatRoomErrorCode errorCode) {
                        MemberRoomGiftPopDialog dialog = new MemberRoomGiftPopDialog(RoomBaseActivity.this, true, true, userInChatListAdapter.getSeatListInRoom(), userList, getRoomType(), authorID);
                        dialog.show();
                    }
                });
                break;
            case R.id.btn_send:
                final String message = etMessage.getText().toString();
                if (message.length() > 31) {
                    Toast.makeText(RoomBaseActivity.this, "输入的内容太长，不能超过31个字符", Toast.LENGTH_LONG).show();
                    return;
                }
                if (!TextUtils.isEmpty(message)) {
                    chatRoom.sendRoomMessage(message, new SendRoomMessageCallback() {
                        @Override
                        public void onSendRoomMessage(ZIMChatRoomErrorCode error) {
                            if (error == ZIMChatRoomErrorCode.SUCCESS) {
                                //存储信息
                                final ZIMChatRoomText text = new ZIMChatRoomText();
                                text.setContent(message);
                                text.setFromUserID(user.getUserID());
                                textMessage.add(text);
                                etMessage.setText("");
                                refreshMessageList();
                            }
                        }
                    });
                }
                break;
        }
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        final SetPopDialog dialog = setPopDialog;
        if (dialog != null) {
            dialog.release();
        }
        //退房
        if (chatRoomInfo != null) {
            chatRoom.setZIMChatRoomEventHandler(null);
            chatRoom.leaveChatRoom(chatRoomInfo.getRoom_id(), new OnLeaveCallback() {
                @Override
                public void onConnectionState(ZIMChatRoomErrorCode error) {

                }
            });
        }
    }


}