package im.zego.zimchatroomdemo.roomchatActivity;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.Toast;

import im.zego.zimchatroom.callback.EnterSeatCallback;
import im.zego.zimchatroom.callback.OnLeaveCallback;
import im.zego.zimchatroom.callback.SwitchSeatCallback;
import im.zego.zimchatroom.emus.ZIMChatRoomErrorCode;
import im.zego.zimchatroom.emus.ZIMChatRoomVoiceStatus;
import im.zego.zimchatroom.entity.ZIMChatRoomUser;
import im.zego.zimchatroom.entity.ZIMVoiceSeat;
import im.zego.zimchatroomdemo.adapter.UserInChatListAdapter;

public class VisitorRoomActivity extends RoomBaseActivity {


    //启动一个Activity的最佳写法
    public static void actionStart(Activity activity, String roomID, String roomName, String userID, String userName) {
        Intent intent = new Intent(activity, VisitorRoomActivity.class);
        intent.putExtra("roomID", roomID);
        intent.putExtra("roomName", roomName);
        intent.putExtra("userID", userID);
        intent.putExtra("userName", userName);
        activity.startActivityForResult(intent, 100);//进行activity的跳转
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        roomID = getIntent().getStringExtra("roomID");
        roomName = getIntent().getStringExtra("roomName");
        userID = getIntent().getStringExtra("userID");
        userName = getIntent().getStringExtra("userName");
        user = new ZIMChatRoomUser();
        user.setUserID(userID);
        user.setUserName(userName);
        user.setUserRole(userRole);

        chatRoomInfo.setRoom_id(roomID);

        chatRoomInfo.setRoom_Name(roomName);

        // 设置麦位管理点击事件
        userInChatListAdapter.setItemOnClick(new UserInChatListAdapter.ChatListItemOnClick() {
            @Override
            public void onClick(final int index) {
                final ZIMVoiceSeat seat = userInChatListAdapter.getSeatListInRoom().get(index);
                if (seat.getStatus() == ZIMChatRoomVoiceStatus.UNUSED) {
                    boolean isSeat = false;
                    for (ZIMVoiceSeat seatInfo : userInChatListAdapter.getSeatListInRoom()) {
                        if (userID.equals(seatInfo.getAttribution().getUser_id())) {
                            isSeat = true;
                        }
                    }
                    if (isSeat) {
                        chatRoom.switchSeat(index, new SwitchSeatCallback() {
                            @Override
                            public void switchSeat(ZIMChatRoomErrorCode error) {

                            }
                        });
                    } else {
                        // 判断是否已经上麦，如果是上麦的话就进行跳麦操作
                        chatRoom.enterSeat(index, new EnterSeatCallback() {
                            @Override
                            public void enterSeat(ZIMChatRoomErrorCode error) {
                                if(error == ZIMChatRoomErrorCode.SEAT_EXISTED){
                                    Toast.makeText(VisitorRoomActivity.this, "该麦位已有人!", Toast.LENGTH_LONG).show();
                                }
                            }
                        });
                    }

                } else if (seat.getStatus() == ZIMChatRoomVoiceStatus.LOCKED) {
                    Toast.makeText(VisitorRoomActivity.this, "该麦位已被锁定!", Toast.LENGTH_LONG).show();

                } else if (seat.getStatus() == ZIMChatRoomVoiceStatus.USED) {
                    Toast.makeText(VisitorRoomActivity.this, "该麦位已有人!", Toast.LENGTH_LONG).show();
                }
            }
        });


    }

    @Override
    protected void onResume() {
        super.onResume();
    }

    @Override
    protected void initUI() {
        super.initUI();
    }

    @Override
    public void onClick(View v) {
        super.onClick(v);
        switch (v.getId()) {
        }
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        //退出房间
        chatRoom.leaveChatRoom(roomID, new OnLeaveCallback() {
            @Override
            public void onConnectionState(ZIMChatRoomErrorCode error) {

            }
        });
    }
}
