package im.zego.zimchatroomdemo.roomchatActivity.popdialog;

import android.content.Context;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

import androidx.recyclerview.widget.GridLayoutManager;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import im.zego.zimchatroom.ZIMChatRoom;
import im.zego.zimchatroom.callback.SendGiftMessageCallback;
import im.zego.zimchatroom.emus.ZIMChatRoomErrorCode;
import im.zego.zimchatroom.entity.ZIMVoiceSeat;
import im.zego.zimchatroomdemo.R;
import im.zego.zimchatroomdemo.adapter.GiftInRoomListAdapter;
import im.zego.zimchatroomdemo.adapter.SendGiftToUserListAdapter;
import im.zego.zimchatroomdemo.enums.GiftType;

import java.util.ArrayList;
import java.util.List;

public class GiftPopDialog extends BasePopDialog implements View.OnClickListener {
    //ui
    private TextView tvGiftTitle;
    private ImageView ivCloseImage;
    private RecyclerView rvSendGiftToUserList;
    private RecyclerView rvGiftList;
    private Button btnSendGift;
    ArrayList<String> userIDs = new ArrayList<>();
    // adapter need
    public ArrayList<GiftType> giftList = new ArrayList<>();
    public ArrayList<ZIMVoiceSeat> usersInSeatExceptSelf = new ArrayList<>();
    static GiftType GIFT_CHOSEN = GiftType.GIFT_666;
    public GiftPopSendCallback callback;
    String userID;

  
    public GiftPopDialog(Context context, int viewID, boolean isCancelable, boolean isBackCancelable, ArrayList<ZIMVoiceSeat> usersInSeatExceptSelf, String userID, GiftPopSendCallback callback) {
        super(context, viewID, isCancelable, isBackCancelable);
        this.callback = callback;
        giftList.add(GiftType.GIFT_666);//现在定死礼物类型
        for (ZIMVoiceSeat seat : usersInSeatExceptSelf) {
            if (!seat.getAttribution().getUser_id().equals(userID)) {
                this.usersInSeatExceptSelf.add(seat);
            }
        }

    }


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setUIFunction();//包含初始化UI和UI的功能设计
    }

    private void initUI() {
        tvGiftTitle = findViewById(R.id.tv_gift_title);
        ivCloseImage = findViewById(R.id.iv_close_image);
        rvSendGiftToUserList = findViewById(R.id.rv_send_gift_to_user_list);
        rvGiftList = findViewById(R.id.rv_gift_list);
        btnSendGift = findViewById(R.id.btn_send_gift);
    }

    private void setUIFunction() {
        initUI();
        ivCloseImage.setOnClickListener(this);
        btnSendGift.setOnClickListener(this);
        //在这个位置进行测试RecyclerView
        GiftInRoomListAdapter giftInRoomListAdapter = new GiftInRoomListAdapter();
        ArrayList<ZIMVoiceSeat> arrayList = new ArrayList<>();
        for (ZIMVoiceSeat seat : usersInSeatExceptSelf) {
            String userID = seat.getAttribution().getUser_id();
            if (userID != null && !"".equals(userID)) {
                arrayList.add(seat);
            }
        }

        SendGiftToUserListAdapter sendGiftToUserListAdapter = new SendGiftToUserListAdapter(arrayList);
        LinearLayoutManager linearLayoutManager = new LinearLayoutManager(context, LinearLayoutManager.HORIZONTAL, false);
        GridLayoutManager gridLayoutManager = new GridLayoutManager(context, 4);
        rvGiftList.setAdapter(giftInRoomListAdapter);
        rvGiftList.setLayoutManager(linearLayoutManager);
        rvSendGiftToUserList.setAdapter(sendGiftToUserListAdapter);
        rvSendGiftToUserList.setLayoutManager(gridLayoutManager);

        sendGiftToUserListAdapter.setItemCheckedChangeListener(new SendGiftToUserListAdapter.ChatListItemOnClick() {
            @Override
            public void onCheckedChanged(int index, String userID, boolean isChecked) {
                if (isChecked) {
                    userIDs.add(userID);
                } else {
                    for (String user : userIDs) {
                        userIDs.remove(user);
                    }
                }
            }
        });
    }

    @Override
    public void onClick(View v) {
        switch (v.getId()) {
            case R.id.iv_close_image:
                cancel();
                break;
            case R.id.btn_send_gift:

                final GiftPopSendCallback sendGiftMessageCallback = callback;
                if (userIDs.size() > 0 && sendGiftMessageCallback != null) {
                    sendGiftMessageCallback.sendGiftMessage(userIDs, GIFT_CHOSEN);
                    cancel();
                } else {
                    userIDs.size();
                    Toast.makeText(context, "请选择赠礼对象", Toast.LENGTH_LONG).show();
                }
                break;
        }
    }

    public interface GiftPopSendCallback {
        void sendGiftMessage(ArrayList<String> userIDs, GiftType giftType);
    }

}
