package im.zego.zimchatroomdemo.roomchatActivity.popdialog;

import android.content.Context;
import android.os.Bundle;
import android.view.Display;
import android.view.View;
import android.view.WindowManager;

import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import im.zego.zimchatroom.ZIMChatRoom;
import im.zego.zimchatroom.callback.SendInvitationStatusCallback;
import im.zego.zimchatroom.emus.ZIMChatRoomErrorCode;
import im.zego.zimchatroom.entity.ZIMChatRoomUser;
import im.zego.zimchatroom.entity.ZIMVoiceSeat;
import im.zego.zimchatroomdemo.R;
import im.zego.zimchatroomdemo.adapter.GiftInRoomListAdapter;
import im.zego.zimchatroomdemo.adapter.UserInRoomListAdapter;
import im.zego.zimchatroomdemo.entity.MemberInfo;
import im.zego.zimchatroomdemo.enums.RoomType;

import java.util.ArrayList;
import java.util.List;

public class MemberRoomGiftPopDialog extends BasePopDialog implements View.OnClickListener {
    private RecyclerView rvUserInRoomList;
    List<ZIMChatRoomUser> userIDs = new ArrayList<>();
    RoomType roomUserRole;
    String authorID;
    public ArrayList<ZIMVoiceSeat> usersInSeatExceptSelf;


    public MemberRoomGiftPopDialog(Context context, boolean isCancelable, boolean isBackCancelable, ArrayList<ZIMVoiceSeat> usersInSeatExceptSelf, List<ZIMChatRoomUser> userList, RoomType roomUserRole, String authorID) {
        super(context, R.layout.pop_member, isCancelable, isBackCancelable);
        this.userIDs = userList;
        this.authorID = authorID;
        this.roomUserRole = roomUserRole;
        this.usersInSeatExceptSelf = usersInSeatExceptSelf;
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        WindowManager m = getWindow().getWindowManager();
        WindowManager.LayoutParams p = getWindow().getAttributes();
        Display d = m.getDefaultDisplay();
        p.height= d.getHeight();
        p.width = d.getWidth();
        getWindow().setAttributes(p);
        setUIFunction();//包含初始化UI和UI的功能设计
    }

    private void initUI() {
        rvUserInRoomList = findViewById(R.id.rv_user_list);
        findViewById(R.id.iv_close_image).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                cancel();
            }
        });
    }

    private void setUIFunction() {
        initUI();
        //在这个位置进行测试RecyclerView
        GiftInRoomListAdapter giftInRoomListAdapter = new GiftInRoomListAdapter();
        ArrayList<MemberInfo> arrayList = new ArrayList<>();
        for (ZIMChatRoomUser userID : userIDs) {
            MemberInfo info = new MemberInfo();
            for (ZIMVoiceSeat seat : usersInSeatExceptSelf) {
                String user_id = seat.getAttribution().getUser_id();
                if (user_id != null && !"".equals(user_id) && userID.getUserID().equals(user_id)) {
                    info.showInvitation = false;
                    info.index = seat.getAttribution().getIndex();
                    break;
                } else {
                    info.showInvitation = true;
                }
            }
            info.userID = userID.getUserID();
            arrayList.add(info);
        }

        LinearLayoutManager linearLayoutManager = new LinearLayoutManager(this.getContext(), LinearLayoutManager.VERTICAL, false);
        UserInRoomListAdapter adapter = new UserInRoomListAdapter(arrayList, roomUserRole, authorID);
        rvUserInRoomList.setAdapter(adapter);
        rvUserInRoomList.setLayoutManager(linearLayoutManager);
        adapter.setItemOnClick(new UserInRoomListAdapter.ChatListItemOnClick() {
            @Override
            public void onClick(String userID) {
                cancel();
                ZIMChatRoom.getInstance().sendInvitation(userID, new SendInvitationStatusCallback() {
                    @Override
                    public void sendInvitationStatus(ZIMChatRoomErrorCode errorCode) {

                    }
                });
            }
        });
    }


    @Override
    public void onClick(View v) {

    }
}
