package im.zego.zimchatroomdemo.roomchatActivity.popdialog;

import static im.zego.zimchatroomdemo.enums.SetType.ALLOW_TAKE_SEAT;

import android.app.Dialog;
import android.content.Context;
import android.os.Bundle;
import android.view.Gravity;
import android.view.View;
import android.view.Window;
import android.view.WindowManager;
import android.widget.CompoundButton;
import android.widget.ImageView;
import android.widget.TextView;

import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import im.zego.zimchatroom.ZIMChatRoom;
import im.zego.zimchatroom.callback.LockSeatCallback;
import im.zego.zimchatroom.callback.MuteAllMessageCallback;
import im.zego.zimchatroom.emus.ZIMChatRoomErrorCode;
import im.zego.zimchatroom.emus.ZIMChatRoomVoiceStatus;
import im.zego.zimchatroom.entity.ZIMVoiceSeat;
import im.zego.zimchatroomdemo.R;
import im.zego.zimchatroomdemo.adapter.SetListAdapter;
import im.zego.zimchatroomdemo.adapter.UserInChatListAdapter;
import im.zego.zimchatroomdemo.enums.SetType;
import im.zego.zimchatroomdemo.widgets.CustomSwitch;

import java.util.ArrayList;

public class SetPopDialog extends BasePopDialog implements View.OnClickListener {
    // ui assets
    private TextView tvSetTitle;
    private ImageView ivCloseImage;
    private RecyclerView rvSetList;

    //adpater
    public SetListAdapter setAdapter;
    //adapter attributions needed
    public ArrayList<SetType> setTypes;
    public boolean isCheckedMuteMessage;
    UserInChatListAdapter adapter;
    public boolean isCheckedTakSeat = false;
    CustomSwitch allowSpeak;
    CustomSwitch takSeat;
    public ArrayList<ZIMVoiceSeat> locked_seat_list = new ArrayList<>();

    public SetPopDialog(Context context, int viewID, boolean isCancelable, boolean isBackCancelable, UserInChatListAdapter adapter) {
        super(context, viewID, isCancelable, isBackCancelable);
        this.adapter = adapter;

    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setUIFunction();
    }

    @Override
    public void cancel() {
        super.cancel();

    }

    private void initUI() {


        findViewById(R.id.iv_close_image).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                cancel();
            }
        });


        allowSpeak = findViewById(R.id.sc_allow_speak);
        allowSpeak.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                //进行静音操作
                ZIMChatRoom.getInstance().muteAllMessage(isChecked, new MuteAllMessageCallback() {
                    @Override
                    public void onMuteAllMessage(ZIMChatRoomErrorCode error) {
                        if (error.equals(ZIMChatRoomErrorCode.SUCCESS)) {
                            isCheckedMuteMessage = isChecked;
                        }
                    }
                });
            }
        });

        takSeat = findViewById(R.id.sc_tak_seat);
        takSeat.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                isCheckedTakSeat = isChecked;
                if (isChecked) {
                    for (ZIMVoiceSeat i : adapter.getSeatListInRoom()) {
                        if (i.getStatus() == ZIMChatRoomVoiceStatus.UNUSED) {
                            ZIMChatRoom.getInstance().lockSeat(true, i.getAttribution().getIndex(), new LockSeatCallback() {
                                @Override
                                public void lockSeat(ZIMChatRoomErrorCode error) {

                                }
                            });
                        }
                    }
                } else {
                    for (ZIMVoiceSeat i : adapter.getSeatListInRoom()) {
                        if (i.getStatus() == ZIMChatRoomVoiceStatus.LOCKED) {
                            ZIMChatRoom.getInstance().lockSeat(false, i.getAttribution().getIndex(), new LockSeatCallback() {
                                @Override
                                public void lockSeat(ZIMChatRoomErrorCode error) {

                                }
                            });
                        }
                    }
                }
            }
        });

    }

    private void setUIFunction() {
        initUI();

    }

    @Override
    public void onClick(View v) {
        switch (v.getId()) {
            case R.id.iv_close_image:
                cancel();
                break;
        }
    }

    public void release() {
        if (takSeat != null && allowSpeak != null) {
            takSeat.release();
            allowSpeak.release();
        }
    }
}
