package im.zego.zimchatroomdemo.utils;

import android.content.SharedPreferences;

import androidx.appcompat.app.AppCompatActivity;

import im.zego.zimchatroomdemo.MyApplication;


/**
 * Copyright © 2016 Zego. All rights reserved.
 * des: Preference管理工具类.
 * 主要用于存储一些临时数据
 */
public class PreferenceUtil {

    /**
     * 单例.
     */
    public static PreferenceUtil sInstance;

    public static final String SHARE_PREFERENCE_NAME = "ZEGO_DEMO_PLAYGROUND";

    public static final String KEY_APP_ID = "PLAYGROUND_APP_ID";
    public static final String KEY_APP_SIGN = "PLAYGROUND_APP_SIGN";
    public static final String KEY_TEST_ENVIRONMENT = "PLAYGROUND_ENV";
    public static final String KEY_SCENARIO = "PLAYGROUND_SCENARIO";
    private SharedPreferences mSharedPreferences;

    private PreferenceUtil() {
        mSharedPreferences = MyApplication.context.getSharedPreferences(SHARE_PREFERENCE_NAME, AppCompatActivity.MODE_PRIVATE);
    }

    public static PreferenceUtil getInstance() {
        if (sInstance == null) {
            synchronized (PreferenceUtil.class) {
                if (sInstance == null) {
                    sInstance = new PreferenceUtil();
                }
            }
        }
        return sInstance;
    }

    public void setStringValue(String key, String value) {
        SharedPreferences.Editor editor = mSharedPreferences.edit();
        editor.putString(key, value);
        editor.commit();
    }

    public String getStringValue(String key, String defaultValue) {
        return mSharedPreferences.getString(key, defaultValue);
    }

    public void setBooleanValue(String key, boolean value) {
        SharedPreferences.Editor editor = mSharedPreferences.edit();
        editor.putBoolean(key, value);
        editor.commit();
    }


    public boolean getBooleanValue(String key, boolean defaultValue) {
        return mSharedPreferences.getBoolean(key, defaultValue);
    }

    public void setIntValue(String key, int value) {
        SharedPreferences.Editor editor = mSharedPreferences.edit();
        editor.putInt(key, value);
        editor.commit();
    }

    public int getIntValue(String key, int defaultValue) {
        return mSharedPreferences.getInt(key, defaultValue);
    }

    public void setLongValue(String key, long value) {
        SharedPreferences.Editor editor = mSharedPreferences.edit();
        editor.putLong(key, value);
        editor.commit();
    }

    public long getLongValue(String key, long defaultValue) {
        return mSharedPreferences.getLong(key, defaultValue);
    }

}