package im.zego.zimchatroom;

import android.content.Context;
import android.util.Log;

import androidx.test.platform.app.InstrumentationRegistry;
import androidx.test.ext.junit.runners.AndroidJUnit4;

import org.junit.Test;
import org.junit.runner.RunWith;

import static org.junit.Assert.*;

import im.zego.zimchatroom.emus.ZIMChatRoomInvitationStatus;
import im.zego.zimchatroom.emus.ZIMChatRoomMessageAction;
import im.zego.zimchatroom.entity.ZIMChatRoomGift;
import im.zego.zimchatroom.entity.ZIMChatRoomGiftBroadcast;
import im.zego.zimchatroom.internal.entity.ZIMChatRoomInfo;
import im.zego.zimchatroom.entity.ZIMChatRoomInvitation;
import im.zego.zimchatroom.entity.ZIMChatRoomInvitationRespond;
import im.zego.zimchatroom.entity.ZIMChatRoomMessage;
import im.zego.zimchatroom.entity.ZIMChatRoomSeatAttribution;
import im.zego.zimchatroom.entity.ZIMChatRoomText;
import im.zego.zimchatroom.util.ByteAndStringTransformer;
import im.zego.zimchatroom.util.GsonChanger;
import im.zego.zimchatroom.util.RoomAttributesChanger;

import java.util.ArrayList;
import java.util.List;

import im.zego.zim.entity.ZIMUserInfo;

/**
 * Instrumented test, which will execute on an Android device.
 *
 * @see <a href="http://d.android.com/tools/testing">Testing documentation</a>
 */
@RunWith(AndroidJUnit4.class)
public class ExampleInstrumentedTest {
    @Test
    public void useAppContext() {
        // Context of the app under test.
        Context appContext = InstrumentationRegistry.getInstrumentation().getTargetContext();
        assertEquals("im.zego.zimchatroom", appContext.getPackageName());
    }
    @Test
    public void getJsonProtocol() {
        //gift
        ZIMChatRoomGift gift = new ZIMChatRoomGift();
        gift.setFromUserID("asfadsf");
        gift.setGiftType(234);
        ZIMUserInfo user = new ZIMUserInfo();
        user.userID = "SAdf";
        //Text文本
        ZIMChatRoomText text = new ZIMChatRoomText();
        text.setFromUserID("Sdfas");
        text.setContent("sadfasfewfewf");
         //invitation
        ZIMChatRoomInvitation invitationMessage = new ZIMChatRoomInvitation();
        invitationMessage.setFromUserID("SD");
        //invitationResponse
        ZIMChatRoomInvitationRespond invitationRespond = new ZIMChatRoomInvitationRespond();
        invitationRespond.setFromUserID("Sd");
        invitationRespond.setStatus(ZIMChatRoomInvitationStatus.REJECT);
        //broadcastGift
        ZIMChatRoomGiftBroadcast giftBroadcast = new ZIMChatRoomGiftBroadcast();
        giftBroadcast.setGiftType(34334);
        List<String> userIDs = new ArrayList<>();
        List<String> userFailIDs = new ArrayList<>();
        userIDs.add("ASFa");
        userIDs.add("a234r23432");
        giftBroadcast.setToUserIDList(userIDs);
        //
        ZIMChatRoomMessage message = new ZIMChatRoomMessage(ZIMChatRoomMessageAction.GIFT,gift);
        ZIMChatRoomMessage message1 = new ZIMChatRoomMessage(ZIMChatRoomMessageAction.TEXT,text);
        ZIMChatRoomMessage message2 = new ZIMChatRoomMessage(ZIMChatRoomMessageAction.INVITATION,invitationMessage);
        ZIMChatRoomMessage message3 = new ZIMChatRoomMessage(ZIMChatRoomMessageAction.INVITATION_RESPOND,invitationRespond);
        ZIMChatRoomMessage message4 = new ZIMChatRoomMessage(ZIMChatRoomMessageAction.GIFT_BROADCAST,giftBroadcast);
        String s = GsonChanger.getInstance().getJsonOfZIMChatRoomMessage(message);
        String s1 = GsonChanger.getInstance().getJsonOfZIMChatRoomMessage(message1);
        String s2 = GsonChanger.getInstance().getJsonOfZIMChatRoomMessage(message2);
        String s3 = GsonChanger.getInstance().getJsonOfZIMChatRoomMessage(message3);
        String s4 = GsonChanger.getInstance().getJsonOfZIMChatRoomMessage(message4);
        Log.d("Json",s);
        //测试一下房间属性可否转为byte，和转回成功
        ByteAndStringTransformer transformer = ByteAndStringTransformer.getInstance();
        Byte[] bytes = transformer.transformToByteArray(s);
        String s_test = transformer.transformToString(bytes);
        ZIMChatRoomMessage roomMessage = GsonChanger.getInstance().getZIMChatRoomMessage(s_test);
        if(s_test.equals(s)){
            Log.d("Json",s);
        }
        GsonChanger.getInstance().getZIMChatRoomMessage(s);
    }
    @Test
    public void ByteAndStringTransformerTest(){
        RoomAttributesChanger changer = RoomAttributesChanger.getInstance();
        ZIMChatRoomSeatAttribution seatAttribution = new ZIMChatRoomSeatAttribution();
        seatAttribution.setIs_muted(false);
        seatAttribution.setIndex(3);
        seatAttribution.setExtras("saf");
        seatAttribution.setUser_id("3r2r");
        Byte[] bytes = changer.getZIMChatRoomSeatAttributionToBytes(seatAttribution);
        ZIMChatRoomSeatAttribution attributionTest = changer.getBytesToZIMChatRoomSeatAttribution(bytes);
        ZIMChatRoomInfo roomInfo = new ZIMChatRoomInfo();
        ArrayList<Integer> arrayList = new ArrayList<Integer>();
        arrayList.add(1);
        arrayList.add(2);
        roomInfo.setLocked_seat_list(arrayList);
        roomInfo.setIs_mute_msg(true);
        roomInfo.setRoom_name("Saa");
        roomInfo.setRoom_id("Ewrew4");
        roomInfo.setAuthor("ere4rte");
        roomInfo.setSeat_count(8);
        bytes = changer.getZIMChatRoomInfoToBytes(roomInfo);
        ZIMChatRoomInfo roomInfoTest = changer.getBytesToZZIMChatRoomInfo(bytes);
        boolean test = roomInfoTest.equals(roomInfo);
    }
}