package im.zego.zimchatroom.callback;

import im.zego.zimchatroom.emus.ZIMChatRoomEvent;
import im.zego.zimchatroom.emus.ZIMChatRoomInvitationStatus;
import im.zego.zimchatroom.emus.ZIMChatRoomState;
import im.zego.zimchatroom.internal.entity.ZIMChatRoomInfo;
import im.zego.zimchatroom.entity.ZIMChatRoomUser;
import im.zego.zimchatroom.entity.ZIMVoiceSeatUpdateInfo;

import org.json.JSONObject;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import im.zego.zim.ZIM;
import im.zego.zim.enums.ZIMConnectionEvent;
import im.zego.zim.enums.ZIMConnectionState;

public  abstract class ZIMChatRoomEventHandler {

    public ZIMChatRoomEventHandler() {
    }

    // RTC Token 将要过期的回调
    public void onRTCTokenWillExpire(String roomID, int remainTimeInSecond){ }

    // ZIM Token 将要过期的回调
    public void onZIMTokenWillExpire(int remainTimeInSecond){ }

    // RTC 模块出现错误时回调
    public void onRTCModuleError(int errorCode) {}

    /**
     房间回调设置
     */
    // 语聊房间状态回调
    public void onChatRoomStateUpdated(ZIMChatRoomState state, ZIMChatRoomEvent event, String roomID){ }

    // 语聊房间信息回调
    public void onChatRoomInfoUpdated(ZIMChatRoomInfo chatRoomInfo){ }

    //用户离开语聊房间回调
    public void onChatRoomMemberLeft(ArrayList<ZIMChatRoomUser> userList){ }

    //用户进入语聊房间回调
    public void onChatRoomMemberJoined(ArrayList<ZIMChatRoomUser> userList){ }

    /**
     * 消息回调设置
    */
    // 接收房间公屏消息回调
    public  void onReceiveRoomMassage(String message,String fromUserID){ }
    // 接收到礼物的回调
    public  void onReceiveGiftMessage(int giftType,String fromUserID) { }
    // 接收房间内礼物广播消息回调
    public  void onReceiveGiftBroadcastMessage(List<String> toUSerIDList, int giftType, String fromUserID){ }
    // 接收邀请上麦的回调
    public  void onReceiveInvitation(String fromUserID){ }
    // 接收回应邀请上麦结果的回调
    public  void onResponseInvitation(ZIMChatRoomInvitationStatus zimChatRoomInvitationStatus, String fromUserID){ }
    //
    public  void onMuteAllMessage(boolean isMuted){ }
    // 连接状态回调
    public void onConnectionStateChanged(ZIMChatRoomState state, ZIMChatRoomEvent event, JSONObject extendedData) {}

    /**
    麦位回调
     */
    // 语聊房间内麦位信息更新回调
    public  void onChatRoomVoiceSeatUpdated(ArrayList<ZIMVoiceSeatUpdateInfo> voiceSeatUpdateInfos){ }
    // 本地用户麦上的声浪信息回调
    public void OnLocalUserSoundLevelUpdated(float soundLevel) { }
    // 远端用户麦上的声浪信息回调
    public void OnRemoteUserSoundLevelUpdated(HashMap<String, Float> soundLevel) { }
}
