package im.zego.zimchatroom.util;

import org.apache.commons.lang.ArrayUtils;

import java.nio.charset.StandardCharsets;

/**
    采用特殊的UTF-8编解码格式
 */
public class ByteAndStringTransformer {
    private static ByteAndStringTransformer instance;
    private ByteAndStringTransformer() {
    }

    public static ByteAndStringTransformer getInstance() {
        if (instance == null) {
            instance = new ByteAndStringTransformer();
        }
        return instance;
    }

    public Byte[] transformToByteArray(String string){
        byte[] bytes = string.getBytes(StandardCharsets.UTF_8);
        return ArrayUtils.toObject(bytes);
    }

    public String transformToString(Byte[] bytes){
        byte[] byteArray = ArrayUtils.toPrimitive(bytes);
        String string = new String(byteArray, StandardCharsets.UTF_8);
        return string;
    }
}