package im.zego.zimchatroom.util;

import im.zego.zimchatroom.internal.entity.ZIMChatRoomInfo;
import im.zego.zimchatroom.entity.ZIMChatRoomMessage;
import im.zego.zimchatroom.entity.ZIMChatRoomSeatAttribution;
import com.google.gson.Gson;

/**
 * 这个工具类是为了将ChatRoom中传递的信息进行json处理
 */
public class GsonChanger {
    private static GsonChanger instance;
    private Gson gson;
    private GsonChanger() {
        gson = new Gson();
    }

    public static GsonChanger getInstance() {
        if (instance == null) {
            instance = new GsonChanger();
        }
        return instance;
    }
    //Message的转化
    public ZIMChatRoomMessage getZIMChatRoomMessage(String json) {
        return gson.fromJson(json,ZIMChatRoomMessage.class);
    }
    public String getJsonOfZIMChatRoomMessage(ZIMChatRoomMessage zimChatRoomMessage) {
        return gson.toJson(zimChatRoomMessage);
    }
    //ZimChatRoomInfo的转化
    public ZIMChatRoomInfo getZIMChatRoomInfo(String json) {
        return  gson.fromJson(json,ZIMChatRoomInfo.class);
    }
    public String getJsonOfZIMChatRoomInfo(ZIMChatRoomInfo zimChatRoomInfo){
        return gson.toJson(zimChatRoomInfo);
    }
    //ZIMChatRoomSeatAttribution的转化
    public ZIMChatRoomSeatAttribution getZIMChatRoomSeatAttribution(String json){
        return gson.fromJson(json,ZIMChatRoomSeatAttribution.class);
    }
    public String getJsonOfZIMChatRoomSeat(ZIMChatRoomSeatAttribution seatAttributes){
        return gson.toJson(seatAttributes);
    }
}