package im.zego.zimchatroom.util;

import im.zego.zimchatroom.internal.entity.ZIMChatRoomInfo;
import im.zego.zimchatroom.entity.ZIMChatRoomSeatAttribution;

public class RoomAttributesChanger {
    //这个是用来将其中的RoomAttribute直接转变为Byte
    private static RoomAttributesChanger instance;
    GsonChanger gsonChanger;
    ByteAndStringTransformer transformer;
    private RoomAttributesChanger() {
        gsonChanger = GsonChanger.getInstance();
        transformer = ByteAndStringTransformer.getInstance();
    }

    public static RoomAttributesChanger getInstance() {
        if (instance == null) {
            instance = new RoomAttributesChanger();
        }
        return instance;
    }
    //将房间里的麦位属性进行转化
    public Byte[] getZIMChatRoomSeatAttributionToBytes(ZIMChatRoomSeatAttribution seat){
        //先对象转字符串，再转byte
        String string = gsonChanger.getJsonOfZIMChatRoomSeat(seat);
       return transformer.transformToByteArray(string);
    }
    public ZIMChatRoomSeatAttribution getBytesToZIMChatRoomSeatAttribution(Byte[] bytes){
        //先转String再对象
        String s = transformer.transformToString(bytes);
        return gsonChanger.getZIMChatRoomSeatAttribution(s);
    }

    //将房间属性进行转化
    public Byte[] getZIMChatRoomInfoToBytes(ZIMChatRoomInfo roomInfo){
        //先对象转字符串，再转byte
        String string = gsonChanger.getJsonOfZIMChatRoomInfo(roomInfo);
        return transformer.transformToByteArray(string);
    }
    public ZIMChatRoomInfo getBytesToZZIMChatRoomInfo(Byte[] bytes){
        //先转String再对象
        String s = transformer.transformToString(bytes);
        return gsonChanger.getZIMChatRoomInfo(s);
    }
}